/*
 *  MAIN, {akii-root}/src/main.c
 *
 * ==========================================================================
 *
 *                      Arena Kliens II. Releases
 *
 * ==========================================================================
 *
 * 1997-1999 Varadi Laszlo (Vazul) <qgivazul@gold.uni-miskolc.hu>
 *                                  <varadi1@iit.uni-miskolc.hu>
 *                                     <vazul@mark.matav.net>
 *
 * Barminemu terjesztese es felhasznalasa a forraskodnak es a binaris
 * fajloknak, valamint azok reszeinek -- valtoztatasokkal vagy anelkul --
 * megengedett /:-)/, de ne feledd, hogy honann hoztad!
 *
 * EZ A PROGRAM VAZUL AGYSZULEMENYE (de sok otlet jott pl. Robitol), ES NEM
 * BIZTOS, HOGY STABILAN MUKODIK MINDENFELE KORULMENYEK KOZOTT! AZ ESETLEGES
 * HIBAKERT, GALIBAKERT FELELOSSEGET NEM VALLALOK, MINDENKI SAJAT MAZOHISTA
 * SZANDEKAIBOL HASZNALJA!
 * ==========================================================================
 *
 * 2002-jelenleg akII Debug Project <akii_info@mail.gyfk.hu>
 *
 * Erre a programra a GNU GPL Licence vonatkozik. A programot mindenki SAJAT
 * FELELOSSEGERE hasznalja. A program altal okozott karokert FELELOSSEGET NEM
 * VALLALUNK!
 * ==========================================================================
 *
 * Megjegyzes: OTLETEKET KEREK MEG! LEGYENEK JOL ATGONDOLTAK, HA LEHET!
 *
 *     Teszteloket, fejlesztoket keresunk kulonbozo, nem x86 platformra!
 *
 * 1997-1999:
 * A friss verziokat itt keresd: <http://www.iit.uni-miskolc.hu/~varadi1/akp>
 *
 * 2002-jelenleg
 * A friss verziokat itt keresd: <http://akii.zold.net/letoltes.php>
 *
 * A legkiralyabb szovegszerkeszto: VIM - Vi IMproved 5  <http://www.vim.org>
 *
 */

#ifdef __CYGWIN32__
#include <sys/types.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <signal.h>
#include <string.h>
#include <netdb.h>
#ifdef _AIX
#include <sys/select.h>
#endif
#include "netread.h"
#include "variables.h"
#include "commands.h"
#include "error.h"
#include "interpreter.h"
#include "terms.h"
#include "screen.h"
#include "regexp.h"
#include "main.h"
#include "debug.h"


#ifndef VERBUILT
#define VERBUILT 0
#endif
#ifndef VERDATE
#define VERDATE "(unknown)"
#endif
#ifndef VERHOST
#define VERHOST "UNKNOWN@UNKNOWN"
#endif
#ifndef VERSYS
#define VERSYS "???"
#endif
#define VER "5.4.8"
#ifdef AKII_DEBUG
#define VERSTR "Arena Kliens II. Release "VER" DEBUG\n[Build #%d, %s, %s, %s]"
#else
#define VERSTR "Arena Kliens II. Release "VER"\n[Build #%d, %s, %s, %s]"
#endif
#define KICSIVERSTR "Arena Kliens II. Release "VER
#define MINIVERSTR "akII R"VER

char host[200] = "arena.zold.net:23";
int port = 23;
char nick[50] = "";
char email[100] = "";
char password[100] = "";
int firstlogin = 1;
int lastact2 = 0, billlastact = 0;
int loadrc = 0;
char rcfile[200] = "~/.akiirc";
char sname[200] = "";
char home[300] = ".";

void letsloop(void);
void resetsignals(void);
void loadakiirc(void);

char *szint[50];
int szini = 0;

char *atstr = NULL;
char *kistr = NULL;
char *fromstr = NULL;
char **kilist = NULL;
int kinevek = 0;

int timeout = 1000;
int floodprotect = 0;
int insertmode = 1;
long starttime;
int beginer = 0;
int ondir = 0;
int elsonevmegjott = 0;

struct msgs *msgk = NULL, *amsg = NULL, *rmsg = NULL;
struct valtozo *akii_timeout;
struct timeval2 sendtimer;

FILE *logfile = NULL;
char logfilename[300] = "";

char sigsemmit[2] = " ";
char sortby_cur = 'N';

void usage(char *akiis)
{
    fprintf(stderr, "Hasznalat:\n %s [-bdcw] [-f floodprotect] [-z ablakmeret] [-s szerver[:port]] [-n nicknev] [-e email] [-p jelszo] [rcfajl]\n \n-b              Botmode: robot modba lep (nem ir a kepernyore, nem fog\n                a billentyuzetrol olvasni.\n-d              Debug mod: az akii.dbg fajlba kiirja, hogy epp melyik\n                fuggvenyben jar, stb.\n-c              Az AKII.NOCS valtozot 1-re allitja.\n                Ez kell buta, CS termcap entry nelkuli terminaloknal.\n-w              Az AKII.USEWIN valtozot 0-ra allitja. Igy kezdetben nem lesz\n                kulon ablak a neveknek.\n-e email        Az email megadasa az uj arena szerver /user parancsahoz !! UJ !!\n-p jelszo       A password megadasa az uj arena szerver /user parancsahoz !! UJ !!\n-z ablakmeret   Kezdet ablakmeretet lehet megadni.\n-f floodprotect Az AKII>FLOODPROTECT kezdeti erteke.\n-s szerver:port Az arena szerver nevet adhatjuk meg, es oda irhatjuk\n                a kettospont utan a port szamat is.\n                Alapertelmezes: arena.zold.net:23\n-n nicknev      Ez lesz a nickneved a login neved helyett, ha megadod.\nrcfajl          A $HOME/.akiirc fajl helyett egy masik script,\n                amit a belogolas utan rogton betolt.\n\nPeldak:         akii -s arena.hu.hix.com -n MrX\n                akii -s mark.matav.net:23 -n MrsX -cwz 6 scripts/x.ak\n                akii -db -n RoBot RoBot.ak\n", akiis);
    return;
}

void parseparams(int argc, char *argv[])
{
    char temp[2048] = "";
    int i, j = 0, rc = 0, z = 0;
    char c = 0, k = 2, *s;
    REXELEM r =
    {0, NULL};

    for (i = 1; i < argc; i++) {
    strcpy(temp + j, argv[i]);
    strcat(temp + j, " ");
    j += strlen(argv[i]) + 1;
    }
    regszavak(temp, &r);
    j = 0;
    for (i = 0; i < r.db; i++) {
    if (j == 1) {
        strncpy(host, r.s[i], 200);
        host[199] = 0;
        j = 0;
        k = 2;
        z = 0;
        continue;
    }
    if (j == 2) {
        strncpy(nick, r.s[i], 30);
        nick[29] = 0;
        j = 0;
        k = 2;
        z = 0;
        continue;
    }
    if (j == 7) {
        strncpy(email, r.s[i], 100);
        email[99] = 0;
        j = 0;
        k = 2;
        z = 0;
        continue;
    }
    if (j == 8) {
        strncpy(password, r.s[i], 100);
        password[99] = 0;
        j = 0;
        k = 2;
        z = 0;
        continue;
    }
    if (j == 3) {
        j = strtol(r.s[i], &s, 10);
        if (s == r.s[i]) {
        j = 5;
        break;
        }
        wantedwinsize = j;
        oldwinsize = j;
        if (winsize)
        winsize = j;
        j = 0;
        k = 2;
        z = 0;
        continue;
    }
    if (j == 4) {
        j = strtol(r.s[i], &s, 10);
        if (s == r.s[i]) {
        j = 6;
        break;
        }
        if (j < 0)
        j = 0;
        if (j > 5000)
        j = 5000;
        floodprotect = j;
        j = 0;
        k = 2;
        z = 0;
        continue;
    }
    if ((strncmp(r.s[i], "-s", 2) == 0) || (c == 's')) {
        j = 1;
        k = 2;
        c = 0;
        z = 0;
        continue;
    }
    if ((strncmp(r.s[i], "-n", 2) == 0) || (c == 'n')) {
        j = 2;
        k = 2;
        c = 0;
        z = 0;
        continue;
    }
    if ((strncmp(r.s[i], "-e", 2) == 0) || (c == 'e')) {
        j = 7;
        k = 2;
        c = 0;
        z = 0;
        continue;
    }
    if ((strncmp(r.s[i], "-p", 2) == 0) || (c == 'p')) {
        j = 8;
        k = 2;
        c = 0;
        z = 0;
        continue;
    }
    if (((strncmp(r.s[i], "-z", 2) == 0) && !z) || (c == 'z')) {
        j = 3;
        k = 2;
        c = 0;
        z = 0;
        continue;
    }
    if (((strncmp(r.s[i], "-f", 2) == 0) && !z) || (c == 'f')) {
        j = 4;
        k = 2;
        c = 0;
        z = 0;
        continue;
    }
    if (((strncmp(r.s[i], "-w", 2) == 0) && !z) || (c == 'w')) {
        usewin = 0;
        winsize = 0;
        c = 0;
        z = 0;
        switch (r.s[i][k]) {
        case 'f':
        case 'z':
        case 'b':
        case 'c':
        case 'd':
        case 's':
        case 'n':
            c = r.s[i][k];
            i--;
            z = 1;
            k++;
        }
        continue;
    }
    if (((strncmp(r.s[i], "-b", 2) == 0) && !z) || (c == 'b')) {
        botmode = 1;
        c = 0;
        z = 0;
        switch (r.s[i][k]) {
        case 'f':
        case 'z':
        case 'w':
        case 'c':
        case 'd':
        case 's':
        case 'n':
            c = r.s[i][k];
            i--;
            k++;
        }
        continue;
    }
    if (((strncmp(r.s[i], "-c", 2) == 0) && !z) || (c == 'c')) {
        nocs = 1;
        c = 0;
        z = 0;
        switch (r.s[i][k]) {
        case 'f':
        case 'z':
        case 'w':
        case 'b':
        case 'd':
        case 's':
        case 'n':
            c = r.s[i][k];
            i--;
            k++;
        }
        continue;
    }
    if (((strncmp(r.s[i], "-d", 2) == 0) && !z) || (c == 'd')) {
        startdbg();
        c = 0;
        z = 0;
        switch (r.s[i][k]) {
        case 'f':
        case 'w':
        case 'c':
        case 'b':
        case 's':
        case 'z':
        case 'n':
            c = r.s[i][k];
            i--;
            k++;
        }
        continue;
    }
    if ((!rc) && (r.s[i][0] != '-')) {
        strncpy(rcfile, r.s[i], 200);
        rcfile[199] = 0;
        rc = 1;
        z = 0;
        continue;
    }
    else {
        if (r.s[i][0] != '-')
        j = 3;
        else
        j = 4;
        break;
    }
    }
    if (j) {
    switch (j) {
        case 1:
        fprintf(stderr, "Hiba: Hianyzik a \"-s\" utan a szervernev! (%s)\n\n", r.s[i]);
        break;
        case 2:
        fprintf(stderr, "Hiba: Hianyzik a \"-n\" utan a nicknev! (%s)\n\n", r.s[i]);
        break;
        case 3:
        fprintf(stderr, "Hiba: Masodik rc fajl is van??? (%s)\n\n", r.s[i]);
        break;
        case 4:
        fprintf(stderr, "Hiba: Ismeretlen opcio: %s\n\n", r.s[i]);
        break;
        case 5:
        fprintf(stderr, "Hiba: Az ablak merete egy szam kell legyen: %s\n\n", r.s[i]);
        break;
        case 6:
        fprintf(stderr, "Hiba: A floodprotektnek egy szamnak kell lennie: %s\n\n", r.s[i]);
        break;
        case 7:
        fprintf(stderr, "Hiba: Hianyzik a \"-e\" utan az email! (%s)\n\n", r.s[i]);
        break;
        case 8:
        fprintf(stderr, "Hiba: Hianyzik a \"-p\" utan a password! (%s)\n\n", r.s[i]);
        break;
    }
    usage(argv[0]);
    torol(&r);
    exit(1);
    }
    torol(&r);
    return;
}

int main(int argc, char *argv[])
{
    char temp[300];
    char *p, *q, *h = host;
    int i;

    starttime = time(NULL);
    sprintf(temp, VERSTR, VERBUILT, VERDATE, VERHOST, VERSYS);
#ifdef __CYGWIN32__
    printf("\033]2;Arena Kliens II.\07");
#endif
    parseparams(argc, argv);
    if (argc == 1)
    beginer = 1;
    p = strchr(host, ':');
    if (p) {
    *p = 0;
    port = strtol(p + 1, NULL, 10);
    if (p == host)
        strcpy(host, "127.0.0.1");
    }
    if (!nick[0]) {
    p = getenv("USER");
    if (!p)
        p = getenv("USERNAME");
    if (p)
        strcpy(nick, p);
    else
        strcpy(nick, "juzer");
    }

    if (!email[0]) {
    p = getenv("HIXNETEMAIL");
    if (p) {
        strncpy(email, p, 100);
        email[99] = 0;
    }
    }

    if (!password[0]) {
    p = getenv("HIXNETPASSWD");
    if (p) {
        strncpy(password, p, 100);
        password[99] = 0;
    }
    }

    i = netconnect(host, port, &h);
    if (i < 0) {
    if (errno <= NO_DATA)
        fprintf(stderr, "Hiba a cim visszanyeresekor: %s\n", host);
    else
        perror("Hiba a csatlakozaskor");
    return (-1);
    }
    p = getenv("HOME");
    if (!p) {
    p = getenv("HOMEDRIVE");
    q = getenv("HOMEPATH");
    if (p && q)
        sprintf(home, "%s%s", p, q);
    else {
        p = strrchr(argv[0], '/');
        if (p) {
        strncpy(home, argv[0], p - argv[0]);
        home[p - argv[0]] = 0;
        }
    }
    }
    else
    strcpy(home, p);
    for (i = 0; i < 50; i++)
    szint[i] = malloc(30);
    initvariables(hostp->h_name, port, nick, temp, VER, VERBUILT);
    initcommands();
    initscreen();
    setivar(akii_termwidth, COLS);
    setivar(akii_termheight, LINES);
    resetsignals();
    inittimers();
    startstopper(&sendtimer);
    p = getenv("TERM");
    if (p)
    if (istrncmp(p, "iris", 4) == 0) {
        akii_usebold->ertek[0] = '0';
        usebold = 0;
    }
    kistr = malloc(2);
    strcpy(kistr, "*");
    letsloop();
    donevariables_fvs();
    donescreen();
    return (0);
}

void sigsemmi(int signo)
{
#ifdef AKII_DEBUG
    sigsemmit[0] = signo + 64;
    dbgenter(dbg_sigsemmi, sigsemmit);
#endif
    signal(signo, sigsemmi);
    return;
}

void rehash(int signo)
{
    loadrc = 2;
    signal(signo, rehash);
    return;
}

void folytat(int signo)
{
    setownterm();
    refresh(1);
    signal(signo, folytat);
    return;
}

void resetsignals(void)
{
    signal(SIGTERM, sigsemmi);
#ifdef SIGPWR
    signal(SIGPWR, sigsemmi);
#endif
    signal(SIGHUP, rehash);
    signal(SIGINT, sigsemmi);
    signal(SIGCONT, folytat);
    return;
}

char *expandtab(char *ezt)
{               /*Inkabb nem tabozok... mert most mar nem jo akkor ide a static!!!
                   ugyhogy most mar csak a sorvegi szokozt szedi le! */
    /*  static char idet[300],*ide;
       int i,j,k;
       ide=idet;
       strcpy(ide,ezt);
       for (i=0;*ezt;ezt++) {
       if ((*ezt)!=9) {
       *ide=*ezt;
       ide++;
       i++;
       }
       else {
       k=i;
       for (j=0;j<8-(k%8);j++) {
       *(ide++)=32;
       i++;
       }
       }
       }
       *ide=0;
       while (*--ide==32) {
       *ide=0;
       if (ide==idet) break;
       }
       return(idet); */
    char *s;

    s = ezt + strlen(ezt);
    while (s > ezt) {
    s--;
    if (isspace(*s))
        *s = 0;
    else
        break;
    }
    return (ezt);
}

char *szin(int fg, int bg, int bd)
{
    int i;

#ifdef AKII_DEBUG
    dbgenter(dbg_szin, "?");
#endif
    if (!fg) {
    strcpy(szint[szini], "\033[0m");
#ifdef AKII_DEBUG
    dbgleave(dbg_szin);
#endif
    return (szint[szini++]);
    }
#ifdef __CYGWIN32__
    sprintf(szint[szini], "\033[0");
    if (usebold || ((!usebold) && (fg == 37) && (!bg)))
    if (bd % 2)
        strcat(szint[szini], ";1");
    bd /= 2;
    if (bd % 2)
    strcat(szint[szini], ";7");
    bd /= 2;
    if (bd % 2)
    strcat(szint[szini], ";4");
    i = strlen(szint[szini]);
    if (bg == 0)
    sprintf(szint[szini] + i, ";%dm", fg);
    else
    sprintf(szint[szini] + i, ";%d;%dm", fg, bg);
#else
    if (bg == 0)
    sprintf(szint[szini], "\033[0;%d", fg);
    else
    sprintf(szint[szini], "\033[0;%d;%d", fg, bg);
    if (usebold || ((!usebold) && (fg == 37) && (!bg)))
    if (bd % 2)
        strcat(szint[szini], ";1");
    bd /= 2;
    if (bd % 2)
    strcat(szint[szini], ";7");
    bd /= 2;
    if (bd % 2)
    strcat(szint[szini], ";4");
    strcat(szint[szini], "m");
#endif
    szini++;
#ifdef AKII_DEBUG
    dbgleave(dbg_szin);
#endif
    return (szint[szini - 1]);
}

void msgadd(char *s)
{
    char *q = s;
    struct msgs *x = msgk;

    if (strlen(s) > 10)
    return;
    while (*q) {
    if (!isalnum(*q))
        return;
    q++;
    }
    if (!msgk) {
    msgk = malloc(sizeof(struct msgs));

    strcpy(msgk->nev, s);
    msgk->prev = msgk->next = NULL;
    rmsg = msgk;
    return;
    }
    while (x) {
    if (istrcmp(x->nev, s) == 0) {
        if (!x->prev)
        return;
        x->prev->next = x->next;
        if (x->next)
        x->next->prev = x->prev;
        else
        rmsg = x->prev;
        msgk->prev = x;
        x->next = msgk;
        x->prev = NULL;
        msgk = x;
        return;
    }
    x = x->next;
    }
    msgk->prev = malloc(sizeof(struct msgs));

    msgk->prev->next = msgk;
    msgk = msgk->prev;
    msgk->prev = NULL;
    strcpy(msgk->nev, s);
    return;
}

void addkilist(char *s)
{
    kinevek++;
    if (!kilist)
    kilist = malloc(10 * sizeof(char *));

    else if (kinevek % 10 == 1) {
    kilist = realloc(kilist, ((kinevek / 10) + 1) * 10 * sizeof(char *));
    }
    kilist[kinevek - 1] = strdup(s);
    return;
}

void freekilist(void)
{
    int i;

    for (i = 0; i < kinevek; i++)
    free(kilist[i]);
    free(kilist);
    kilist = NULL;
    return;
}

int sortkilist(const void *a, const void *b)
{
    switch (sortby_cur) {
    case 'S':
        return (0);
    case 'N':
        return (istrncmp((*(char **) a), (*(char **) b), 11));
    case 'C':
        return (istrncmp((*(char **) a) + 14, (*(char **) b) + 14, 11));
    case 'F':
        return (istrcmp((*(char **) a) + 37, (*(char **) b) + 37));
    }
    return (0);
}

void shorten(char *s)
{
    int i, j;

    if (strlen(s) < COLS - 1)
    return;
    if (COLS < 40) {
    s[COLS - 1] = 0;
    return;
    }
    j = strlen(s) - COLS + 1;
    for (i = 0; s[42 + i + j]; i++) {
    s[42 + i] = s[42 + i + j];
    }
    s[42 + i] = 0;
    s[42] = '.';
    s[43] = '.';
    s[44] = '.';
    return;
}

void elemez(char *s)
{
    int tovabb = 1;
    int i, j, l, pr, jump = 0;
    REXELEM r =
    {0, NULL}, q =
    {0, NULL};
    struct onstr *on = onlist;
    char *toretlenargs_save = toretlenargs;
    char **numvarlist_save = numvarlist;
    char **chvarlist_save = chvarlist;
    char *p;
    static char temp[800];
    static char temp2[800] = "";
    int id = 0;
    char *t, *withoutid;
    struct valtozo *var;
    int kezelve = 0;

    s = expandtab(s);
#ifdef AKII_DEBUG
    dbgenter(dbg_elemez, s);
#endif
    toretlenargs = s;
    j = regszavak(s, &q);
    if (j > 0) {
    numvarlist = malloc(sizeof(char *) * (j + 1));

    numvarlist[0] = (char *) j;
    for (; j; j--)
        numvarlist[j] = q.s[j - 1];
    free(q.s);
    }
    else
    numvarlist = NULL;

    if (s[0] == '[') {
    id = strtol(s + 1, NULL, 10);
    if (id) {
        p = strchr(s + 1, ']');
        if (p)
        withoutid = p + 1;
    }
    }
    else
    withoutid = s;

    if ((j = regprobal(withoutid, "\\*from: %\\* *", &r)) >= 0) {
    msgadd(r.s[0]);
    torol(&r);
    }
    if ((isalpha(s[0]) || s[0] == '-') && kinevek >= 0)
    if ((j = regprobal(s, "[a-z0-9\\-]+ [ ]+= [@*a-z0-9]+[ ]+[@*]+0-1[#rwx.]+3 [ 0-9]+4mp %:*", &r)) >= 0) {
        elsonevmegjott++;
        if (ondir) {
        addkilist(s);
        freenumvarlist(&numvarlist);
        toretlenargs = toretlenargs_save;
        numvarlist = numvarlist_save;
        chvarlist = chvarlist_save;
#ifdef AKII_DEBUG
        dbgleave(dbg_elemez);
#endif
        return;
        }
        if (kistr) {
        if (regprobal(r.s[0], kistr, NULL) < 0) {
            freenumvarlist(&numvarlist);
            toretlenargs = toretlenargs_save;
            numvarlist = numvarlist_save;
            chvarlist = chvarlist_save;
#ifdef AKII_DEBUG
            dbgleave(dbg_elemez);
#endif
            return;
        }
        }
        else if (atstr) {
        if (regprobal(r.s[2], atstr, NULL) < 0) {
            freenumvarlist(&numvarlist);
            toretlenargs = toretlenargs_save;
            numvarlist = numvarlist_save;
            chvarlist = chvarlist_save;
#ifdef AKII_DEBUG
            dbgleave(dbg_elemez);
#endif
            return;
        }
        }
        else if (fromstr) {
        if (regprobal(r.s[7], fromstr, NULL) < 0) {
            freenumvarlist(&numvarlist);
            toretlenargs = toretlenargs_save;
            numvarlist = numvarlist_save;
            chvarlist = chvarlist_save;
#ifdef AKII_DEBUG
            dbgleave(dbg_elemez);
#endif
            return;
        }
        }
        addkilist(s);
        freenumvarlist(&numvarlist);
        toretlenargs = toretlenargs_save;
        numvarlist = numvarlist_save;
        chvarlist = chvarlist_save;
#ifdef AKII_DEBUG
        dbgleave(dbg_elemez);
#endif
        return;
    }
    if (!*s && elsonevmegjott) {
    temp2[0] = 0;
    elsonevmegjott = 0;
    if (atstr) {
        if (!kinevek)
        sprintf(temp2, ">>> Nem talaltam megfelelo szemelyt: AT: %s", atstr);
        else
        sprintf(temp2, ">>> AT \"%s\": %d nevet talaltam", atstr, kinevek);
        if (usewin)
        sprintf(winbase_temp, "/AT \"%s\" lista", atstr);
        free(atstr);
    }
    else if (kistr) {
        if (!kinevek)
        sprintf(temp2, ">>> Nem talaltam megfelelo szemelyt: KI: %s", kistr);
        else
        sprintf(temp2, ">>> KI \"%s\": %d nevet talaltam", kistr, kinevek);
        if (usewin)
        sprintf(winbase_temp, "/KI \"%s\" lista", kistr);
        free(kistr);
    }
    else if (fromstr) {
        if (!kinevek)
        sprintf(temp2, ">>> Nem talaltam megfelelo szemelyt: FROM: %s", fromstr);
        else
        sprintf(temp2, ">>> FROM \"%s\": %d nevet talaltam", fromstr, kinevek);
        if (usewin)
        sprintf(winbase_temp, "/FROM \"%s\" lista", fromstr);
        free(fromstr);
    }
    atstr = kistr = fromstr = NULL;
    if (kinevek) {
        qsort(kilist, kinevek, sizeof(char *), sortkilist);

        if (ondir) {
        ondir = 0;
        sprintf(temp2, "@@@ Rovid nevlista(%d): ", kinevek);
        for (i = 0; i < kinevek; i++) {
            *strchr(kilist[i], ' ') = 0;
            sprintf(temp2 + strlen(temp2), "%s, ", kilist[i]);
        }
        freekilist();
        elemez(temp2);
        kinevek = 0;
        temp2[0] = 0;
        freenumvarlist(&numvarlist);
        toretlenargs = toretlenargs_save;
        numvarlist = numvarlist_save;
        chvarlist = chvarlist_save;
#ifdef AKII_DEBUG
        dbgleave(dbg_elemez);
#endif
        return;
        }
        i = kinevek;
        kinevek = -kinevek;
        for (j = 0; j < i; j++)
        elemez(kilist[j]);  /*minden sor atmegy, de az akii nem irja ki a negativ 'kinevek' miatt */
        if (*temp2)
        elemez(temp2);
        elemez("");     /*negativ kinevek, ez az ize sor -> ekkor ir az ablakba */
        freekilist();
        kinevek = 0;
        *temp2 = 0;
        freenumvarlist(&numvarlist);
        toretlenargs = toretlenargs_save;
        numvarlist = numvarlist_save;
        chvarlist = chvarlist_save;
#ifdef AKII_DEBUG
        dbgleave(dbg_elemez);
#endif
        return;
    }
    else if (*temp2) {
        kinevek = -1;
        elemez(temp2);
        elemez("");
        kinevek = 0;
        *temp2 = 0;
        freenumvarlist(&numvarlist);
        toretlenargs = toretlenargs_save;
        numvarlist = numvarlist_save;
        chvarlist = chvarlist_save;
#ifdef AKII_DEBUG
        dbgleave(dbg_elemez);
#endif
        return;
    }
    }

    if (s[0] == '/')
    if ((j = regprobal(s, "/// *", &r)) >= 0) {
        sprintf(temp, "%s///%s %s", szin(34, 0, 1), szin(0, 0, 0), r.s[0]);
        echostr(temp);
        torol(&r);
        szini = 0;
        kezelve = 1;
    }
    if (s[0] == '@')
    if ((j = regprobal(s, "@@@ *", &r)) >= 0) {
        sprintf(temp, "%s@@@%s %s", szin(32, 0, 1), szin(0, 0, 0), r.s[0]);
        echostr(temp);
        torol(&r);
        szini = 0;
        kezelve = 1;
    }
    if (s[0] == '=')
    if ((j = regprobal(s, "=== HIBA ===*", &r)) >= 0) {
        sprintf(temp, "%s=== HIBA ===%s%s", szin(33, 41, 1), szin(0, 0, 0), r.s[0]);
        echostr(temp);
        torol(&r);
        szini = 0;
        kezelve = 2;
    }

    if (kezelve) {
    toretlenargs = toretlenargs_save;
    numvarlist = numvarlist_save;
    chvarlist = chvarlist_save;
#ifdef AKII_DEBUG
    dbgleave(dbg_elemez);
#endif
    return;
    }
    if ((j = regprobal(withoutid, "\\*from: %\\* \\[ak\\]-AutoAkverQuestion-", &r)) >= 0) {
    var = getvar2("akii.verzio");
    sprintf(temp, "/msg %s %s /idle: %d sec/", r.s[0], (var) ? var->ertek : "akII unknown", time(NULL) - billlastact);
    sendline(temp);
    torol(&r);
    }
    if (firstlogin) {
    if ((j = regprobal(s, "\\*\\*\\* Eloszor *", NULL)) >= 0) {
            if (strlen(email) && strlen(password)) {
                    sprintf(temp, "/user %s %s\n", email, password);
                    netwrite(temp);
            }
            sprintf(temp, "/nev %s\n", nick);
        netwrite(temp);
    }
    if ((j = regprobal(s, "\\*\\*\\* Uj latogato: % *", &r)) >= 0) {
        var = getvar2("akii.nick");
        if (var) {
        free(var->ertek);
        var->ertek = malloc(strlen(r.s[0]) + 1);
        strcpy(var->ertek, r.s[0]);
        }
        strcpy(nick, r.s[0]);
        torol(&r);
        loadrc = 1;
        firstlogin = 0;
    }
    }
    sprintf(temp, "\\*\\*\\* %s csatlakozott a csatornahoz: %%", nick);
    if ((j = regprobal(withoutid, temp, &r)) >= 0) {
    var = getvar2("akii.csatorna");
    if (var) {
        free(var->ertek);
        var->ertek = malloc(strlen(r.s[0]) + 1);
        strcpy(var->ertek, r.s[0]);
    }
    torol(&r);
    }

    while (on) {
    if (on->szint < 0)
        break;
    if (jump) {
        if (on->szint > nexton_level)
        continue;
        jump = 0;
    }
    r.db = 0;
    r.s = NULL;
    l = on->kifek;
    if (!on->tiltott)
        for (i = 0; i < l; i++) {
        p = parsedollar(on->regkifek[i]);
        if (errno) {
            freenumvarlist(&numvarlist);
            toretlenargs = toretlenargs_save;
            numvarlist = numvarlist_save;
            chvarlist = chvarlist_save;
#ifdef AKII_DEBUG
            dbgleave(dbg_elemez);
#endif
            return;
        }
        j = regprobal(s, p, &r);
        free(p);
        if (j >= 0) {
            if (j) {
            chvarlist = malloc(sizeof(char *) * (j + 1));

            chvarlist[0] = (char *) j;
            for (; j; j--)
                chvarlist[j] = r.s[j - 1];
            free(r.s);
            }
            kerdojel = i + 1;
            on->justmark++;
            locallevel++;
            pr = doparancssor(on->par);
            freenumvarlist(&chvarlist);
            freevarlist(localvars[locallevel--], 1);
            on->justmark--;
            freenumvarlist(&chvarlist);
            if ((on->tipus == '!') || (pr == DO_NOMOREON))
            tovabb = 0;
            if (pr == DO_NEXTON) {
            tovabb = 1;
            jump = 1;
            if (nexton_level == (int) 3e7)
                jump = 0;
            }
            if (on->justmark > 500)
            on = freeoneon(on, 0);
            else
            on = on->next;
            break;
        }
        }
    else
        i = l;
    if (i == l)
        on = on->next;
    if (!tovabb)
        break;
    if (on)
        if (on->szint < 0)
        break;
    }
    if (!tovabb) {
    freenumvarlist(&numvarlist);
    toretlenargs = toretlenargs_save;
    numvarlist = numvarlist_save;
    chvarlist = chvarlist_save;
#ifdef AKII_DEBUG
    dbgleave(dbg_elemez);
#endif
    return;
    }
    r.db = 0;
    r.s = NULL;
    if (jump && (!nexton_level))
    jump = 0;
    if (!jump) {
    if (withoutid[0] == '*' && withoutid[1] == '*' && withoutid[2] == '*')
        if ((j = regprobal(withoutid, "\\*\\*\\* *", &r)) >= 0) {
        if (!id)
            sprintf(temp, "%s***%s %s", szin(37, 0, 1), szin(0, 0, 0), r.s[0]);
        else
            sprintf(temp, "%s[%3d]%s***%s %s", szin(36, 0, 0), id, szin(37, 0, 1), szin(0, 0, 0), r.s[0]);
        echostr(temp);
        torol(&r);
        szini = 0;
        kezelve = 2;
        }
    if ((j = regprobal(withoutid, "\\*from: %\\* *", &r)) >= 0) {
        if (!id)
        sprintf(temp, "%s*from: %s*%s %s", szin(32, 0, 1), r.s[0], szin(0, 0, 0), r.s[1]);
        else
        sprintf(temp, "%s[%3d]%s*from: %s*%s %s", szin(36, 0, 0), id, szin(32, 0, 1), r.s[0], szin(0, 0, 0), r.s[1]);
        echostr(temp);
        torol(&r);
        szini = 0;
        kezelve = 2;
    }

    if ((j = regprobal(withoutid, "\\*\\* % *", &r)) >= 0) {
        if (!id)
        sprintf(temp, "%s** %s%s %s", szin(32, 0, 1), r.s[0], szin(0, 0, 0), r.s[1]);
        else
        sprintf(temp, "%s[%3d]%s** %s%s %s", szin(36, 0, 0), id, szin(32, 0, 1), r.s[0], szin(0, 0, 0), r.s[1]);
        echostr(temp);
        torol(&r);
        szini = 0;
        kezelve = 2;
    }
    if ((j = regprobal(withoutid, "\\*%\\*\\* *", &r)) >= 0) {
        if (r.s[0][0]!=0) {
            sprintf(temp, "%s*%s**%s %s", szin(36, 0, 1), r.s[0], szin(0, 0, 0), r.s[1]);
            echostr(temp);
            torol(&r);
            szini = 0;
            kezelve = 2;
        }
    }

    if ((j = regprobal(withoutid, "\\*to: %\\* *", &r)) >= 0) {
        sprintf(temp, "%s*to: %s*%s %s", szin(36, 0, 1), r.s[0], szin(0, 0, 0), r.s[1]);
        echostr(temp);
        torol(&r);
        szini = 0;
        kezelve = 2;
    }
    if (withoutid[0] == '<') {
        sprintf(temp, "<%%:%s> *", nick);
        if ((j = regprobal(withoutid, temp, &r)) >= 0) {
        if (!id)
            sprintf(temp, "%s<%s%s:%s%s>%s %s", szin(33, 0, 1), szin(0, 0, 0), r.s[0], nick, szin(33, 0, 1), szin(0, 0, 0), r.s[1]);
        else
            sprintf(temp, "%s[%3d]%s<%s%s:%s%s>%s %s", szin(36, 0, 0), id, szin(33, 0, 1), szin(0, 0, 0), r.s[0], nick, szin(33, 0, 1), szin(0, 0, 0), r.s[1]);
        echostr(temp);
        kezelve = 2;
        szini = 0;
        torol(&r);
        }
        sprintf(temp, "<%s> *", nick);
        if ((j = regprobal(withoutid, temp, &r)) >= 0) {
        if (!id)
            sprintf(temp, "%s<%s%s%s>%s %s", szin(33, 0, 1), szin(0, 0, 0), nick, szin(33, 0, 1), szin(0, 0, 0), r.s[0]);
        else
            sprintf(temp, "%s[%3d]%s<%s%s%s>%s %s", szin(36, 0, 0), id, szin(33, 0, 1), szin(0, 0, 0), nick, szin(33, 0, 1), szin(0, 0, 0), r.s[0]);
        echostr(temp);
        kezelve = 2;
        szini = 0;
        torol(&r);
        }
        sprintf(temp, "<%%:%%> *%s*", nick);
        if (!kezelve)
        if ((j = regprobal(withoutid, temp, &r)) >= 0) {
            t = strchr(s, '>');
            t += 2;
            if (!id)
            sprintf(temp, "<%s:%s%s%s> %s", r.s[0], szin(33, 0, 1), r.s[1], szin(0, 0, 0), t);
            else
            sprintf(temp, "%s[%3d]%s<%s:%s%s%s> %s", szin(36, 0, 0), id, szin(0, 0, 0), r.s[0], szin(33, 0, 1), r.s[1], szin(0, 0, 0), t);
            echostr(temp);
            kezelve = 2;
            szini = 0;
            torol(&r);
        }
        sprintf(temp, "<%%> *%s*", nick);
        if (!kezelve)
        if ((j = regprobal(withoutid, temp, &r)) >= 0) {
            t = strchr(s, '>');
            t += 2;
            if (!id)
            sprintf(temp, "<%s%s%s> %s", szin(33, 0, 1), r.s[0], szin(0, 0, 0), t);
            else
            sprintf(temp, "%s[%3d]%s<%s%s%s> %s", szin(36, 0, 0), id, szin(0, 0, 0), szin(33, 0, 1), r.s[0], szin(0, 0, 0), t);
            echostr(temp);
            kezelve = 2;
            szini = 0;
            torol(&r);
        }
        if (!kezelve && id) {
        sprintf(temp, "%s[%3d]%s%s", szin(36, 0, 0), id, szin(0, 0, 0), withoutid);
        echostr(temp);
        kezelve = 2;
        szini = 0;
        }

    } else if ((withoutid[0] == '*') && (withoutid[1]==' ')) {

        sprintf(temp, "\\* %s *", nick);
        if ((j = regprobal(withoutid, temp, &r)) >= 0) {
        if (!id)
            sprintf(temp, "%s*%s %s %s", szin(33, 0, 1), szin(0, 0, 0), nick, r.s[0]);
        else
            sprintf(temp, "%s[%3d]%s*%s %s %s", szin(36, 0, 0), id, szin(33, 0, 1), szin(0, 0, 0), nick, r.s[0]);
        echostr(temp);
        kezelve = 2;
        szini = 0;
        torol(&r);
        }

        sprintf(temp, "\\* %% *%s*", nick);
        if (!kezelve)
        if ((j = regprobal(withoutid, temp, &r)) >= 0) {
            t = strchr(&(s[2]), ' ');
            t += 1;
            if (!id)
            sprintf(temp, "* %s%s%s %s", szin(33, 0, 1), r.s[0], szin(0, 0, 0), t);
            else
            sprintf(temp, "%s[%3d]%s* %s%s%s %s", szin(36, 0, 0), id, szin(0, 0, 0), szin(33, 0, 1), r.s[0], szin(0, 0, 0), t);
            echostr(temp);
            kezelve = 2;
            szini = 0;
            torol(&r);
        }

        if (!kezelve && id) {
        sprintf(temp, "%s[%3d]%s%s", szin(36, 0, 0), id, szin(0, 0, 0), withoutid);
        echostr(temp);
        kezelve = 2;
        szini = 0;
        }


    }
    if ((j = regprobal(s, ">>> Idle*", NULL)) >= 0) {
        if ((time(NULL) - lastact2) > timeout)
        netwrite("/msg xx\n");
    }
    if (((*s == '>') && usewin && (kinevek < 0))) {     /*'>>>' sor, negativ kinevek, usewin ->ablakba iras */
        strcpy(winbase, winbase_temp);
        if (!winsize) {
        winsize = oldwinsize;
        setivar(akii_winsize, winsize);
        }
        winclear();
        writewindow();
        if (kilist)
        for (j = 0; j < -kinevek; j++) {
            shorten(kilist[j]);
            winechostr(kilist[j]);
        }
        else {
        shorten(s);
        winechostr(s);
        }
        freenumvarlist(&numvarlist);
        toretlenargs = toretlenargs_save;
        numvarlist = numvarlist_save;
        chvarlist = chvarlist_save;
#ifdef AKII_DEBUG
        dbgleave(dbg_elemez);
#endif
        return;
    }
    if (s[0] == '>')
        if ((j = regprobal(s, ">>> *", &r)) >= 0) {
        sprintf(temp, "%s>>>%s %s", szin(31, 0, 1), szin(0, 0, 0), r.s[0]);
        echostr(temp);
        torol(&r);
        szini = 0;
        kezelve = 1;
        }
    if ((!kezelve) && ((!*s) && usewin && (kinevek < 0))) {
        freenumvarlist(&numvarlist);
        toretlenargs = toretlenargs_save;
        numvarlist = numvarlist_save;
        chvarlist = chvarlist_save;
#ifdef AKII_DEBUG
        dbgleave(dbg_elemez);
#endif
        return;
    }
    if ((!kezelve) && ((kinevek >= 0) || (!usewin)))
        echostr(s);
    }
    while (on) {
    if (jump) {
        if (on->szint > nexton_level)
        continue;
        jump = 0;
    }
    r.db = 0;
    r.s = NULL;
    l = on->kifek;
    if (!on->tiltott)
        for (i = 0; i < l; i++) {
        p = parsedollar(on->regkifek[i]);
        if (errno) {
            freenumvarlist(&numvarlist);
            toretlenargs = toretlenargs_save;
            numvarlist = numvarlist_save;
            chvarlist = chvarlist_save;
#ifdef AKII_DEBUG
            dbgleave(dbg_elemez);
#endif
            return;
        }
        j = regprobal(s, p, &r);
        free(p);
        if (j >= 0) {
            if (j) {
            chvarlist = malloc(sizeof(char *) * (j + 1));

            chvarlist[0] = (char *) j;
            for (; j; j--)
                chvarlist[j] = r.s[j - 1];
            free(r.s);
            }
            kerdojel = i + 1;
            on->justmark++;
            locallevel++;
            pr = doparancssor(on->par);
            freenumvarlist(&chvarlist);
            freevarlist(localvars[locallevel--], 1);
            on->justmark--;
            freenumvarlist(&chvarlist);
            if ((on->tipus == '!') || (pr == DO_NOMOREON))
            tovabb = 0;
            if (pr == DO_NEXTON) {
            jump = 1;
            tovabb = 1;
            if (nexton_level == (int) 3e7)
                jump = 0;
            }
            if (on->justmark > 500)
            on = freeoneon(on, 0);
            else
            on = on->next;
            break;
        }
        }
    else
        i = l;
    if (i == l)
        on = on->next;
    if (!tovabb)
        break;
    }
    freenumvarlist(&numvarlist);
    toretlenargs = toretlenargs_save;
    numvarlist = numvarlist_save;
    chvarlist = chvarlist_save;
#ifdef AKII_DEBUG
    dbgleave(dbg_elemez);
#endif
    return;
}

void sendline(char *s)
{
    int tovabb = 1;
    int i, j, l, pr, jump = 0;
    REXELEM r =
    {0, NULL}, q =
    {0, NULL};
    struct onstr *on = onsendlist;
    char *toretlenargs_save = toretlenargs;
    char *p, *w, *e;
    char **numvarlist_save = numvarlist;
    char **chvarlist_save = chvarlist;
    char stemp[1024];

#ifdef AKII_DEBUG
    dbgenter(dbg_sendline, s);
#endif
    w = strchr(s, '\n');
    if (w) {
    *w = 0;
    e = w;
    }
    else
    e = s + strlen(s);
    if (e && *s)
    while (*(e - 1) == 32) {
        *--e = 0;
        w = e;
        if (e == s)
        break;
    }
    toretlenargs = s;
    j = regszavak(s, &q);
    if (j >= 0) {
    numvarlist = malloc(sizeof(char *) * (j + 1));

    numvarlist[0] = (char *) j;
    for (; j; j--)
        numvarlist[j] = q.s[j - 1];
    free(q.s);
    }
    else
    numvarlist = NULL;
    if ((int) numvarlist[0] >= 2) {
    if (istrcmp("/msg", numvarlist[1]) == 0) {
        msgadd(numvarlist[2]);
    }
    }
    while (on) {
    r.db = 0;
    r.s = NULL;
    l = on->kifek;
    if (!on->tiltott)
        for (i = 0; i < l; i++) {
        p = parsedollar(on->regkifek[i]);
        if (errno) {
            freenumvarlist(&numvarlist);
            toretlenargs = toretlenargs_save;
            numvarlist = numvarlist_save;
            chvarlist = chvarlist_save;
#ifdef AKII_DEBUG
            dbgleave(dbg_sendline);
#endif
            return;
        }
        j = regprobal(s, p, &r);
        free(p);
        if (j >= 0) {
            if (j) {
            chvarlist = malloc(sizeof(char *) * (j + 1));

            chvarlist[0] = (char *) j;
            for (; j; j--)
                chvarlist[j] = r.s[j - 1];
            free(r.s);
            }
            kerdojel = i + 1;
            on->justmark++;
            locallevel++;
            pr = doparancssor(on->par);
            freenumvarlist(&chvarlist);
            freevarlist(localvars[locallevel--], 1);
            on->justmark--;
            freenumvarlist(&chvarlist);
            if ((on->tipus == '!') || (pr == DO_NOMOREON))
            tovabb = 0;
            if (pr == DO_NEXTON) {
            jump = 1;
            tovabb = 1;
            if (nexton_level == (int) 3e7)
                jump = 0;
            }
            if (on->justmark > 500)
            on = freeoneon(on, 0);
            else
            on = on->next;
            break;
        }
        }
    else
        i = l;
    if (i == l)
        on = on->next;
    if (!tovabb)
        break;
    if (on)
        if (on->szint < 0)
        break;
    }
    if (!tovabb) {
    freenumvarlist(&numvarlist);
    toretlenargs = toretlenargs_save;
    numvarlist = numvarlist_save;
    chvarlist = chvarlist_save;
#ifdef AKII_DEBUG
    dbgleave(dbg_sendline);
#endif
    return;
    }
    strcpy(stemp, s);
    strcat(stemp, "\n");
    netwrite(stemp);
    while (on) {
    r.db = 0;
    r.s = NULL;
    l = on->kifek;
    if (!on->tiltott)
        for (i = 0; i < l; i++) {
        p = parsedollar(on->regkifek[i]);
        if (errno) {
            freenumvarlist(&numvarlist);
            toretlenargs = toretlenargs_save;
            numvarlist = numvarlist_save;
            chvarlist = chvarlist_save;
#ifdef AKII_DEBUG
            dbgleave(dbg_sendline);
#endif
            return;
        }
        j = regprobal(s, p, &r);
        free(p);
        if (j >= 0) {
            if (j) {
            chvarlist = malloc(sizeof(char *) * (j + 1));

            chvarlist[0] = (char *) j;
            for (; j; j--)
                chvarlist[j] = r.s[j - 1];
            free(r.s);
            }
            kerdojel = i + 1;
            on->justmark++;
            locallevel++;
            pr = doparancssor(on->par);
            freenumvarlist(&chvarlist);
            freevarlist(localvars[locallevel--], 1);
            on->justmark--;
            freenumvarlist(&chvarlist);
            if ((on->tipus == '!') || (pr == DO_NOMOREON))
            tovabb = 0;
            if (pr == DO_NEXTON) {
            jump = 1;
            if (nexton_level == (int) 3e7)
                jump = 0;
            tovabb = 1;
            }
            if (on->justmark > 500)
            on = freeoneon(on, 0);
            else
            on = on->next;
            break;
        }
        }
    else
        i = l;
    if (i == l)
        on = on->next;
    if (!tovabb)
        break;
    if (on)
        if (on->szint < 0)
        break;
    }
    freenumvarlist(&numvarlist);
    toretlenargs = toretlenargs_save;
    numvarlist = numvarlist_save;
    chvarlist = chvarlist_save;
#ifdef AKII_DEBUG
    dbgleave(dbg_sendline);
#endif
    return;
}

void lookfortimers(time_t ido)
{
    struct timerstr *t = timerlist, *q;
    char *blockname_save=blockname;

#ifdef AKII_DEBUG
    dbgenter(dbg_lookfortimers, "?");
#endif
    while (t) {
    if ((ido - t->last) >= t->ido) {
        locallevel++;
        if (!t->tiltott) {
                blockname=t->nev;
        doparancssor(t->par);
                blockname=blockname_save;
            }
        freevarlist(localvars[locallevel--], 1);
        if (t->tipus == '!') {
        if (t->nev)
            free(t->nev);
        freepar(t->par);
        if (t->next)
            t->next->prev = t->prev;
        if (t->prev)
            t->prev->next = t->next;
        else
            timerlist = t->next;
        q = t->next;
        free(t);
        t = q;
        }
        else {
        t->last = ido;
        t = t->next;
        }
    }
    else
        t = t->next;
    }
#ifdef AKII_DEBUG
    dbgleave(dbg_lookfortimers);
#endif
    return;
}

void loadakiirc(void)
{
    char temp[300];

#ifdef AKII_DEBUG
    dbgenter(dbg_loadakiirc, "?");
#endif
    load(rcfile);
    if (errno == ENOFILE) {
    if (beginer == 1) {
        beginer = 2;
        elemez(">>> Kezdoknek: ezzel lekerheted az osszes parancsot: '/echo $fv()'");
        elemez(">>> ezek kozul van, ami nem \"lathato\" eredmenyt ad (ilyen volt a FV is elobb)");
        elemez(">>> Olvasgasd: http://www.iit.uni-miskolc.hu/~varadi1/akp/");
    }
    errno = 0;
    }
    if (errno) {
    if (novice) {
        sprintf(temp, "=== HIBA === %s", geterrorstr(getlasterror()));
    }
    else {
        sprintf(temp, "=== HIBA === %d: %s", errno, geterrorstr(getlasterror()));
    }
    errno = 0;
    elemez(temp);
    }
#ifdef AKII_DEBUG
    dbgleave(dbg_loadakiirc);
#endif
    return;
}

void kilepes(char *s)
{
    int i;

    donevariables_fvs();
    dbgenter(dbg_NORMALEXIT, s);
    closedbg();
    freeinplines();
    if (logfile) {
    numvarlist = malloc(sizeof(char *));

    numvarlist[0] = NULL;
    fv_log(NULL);
    free(numvarlist);
    }
    printf("\033[r\033[37;1H");
    donescreen();
    for (i = 0; i < 50; i++)
    free(szint[i]);
    exit(0);
    return;
}

void backspace(void)
{
    int i;

    if (cursor == 1)
    return;
    cursor--;
    for (i = cursor; i <= inplen; i++)
    inp[i - 1] = inp[i];
    inp[--inplen] = 0;
    return;
}

void insert(char p)
{
    int i;

    if ((!insertmode) && (inplen != cursor - 1)) {
    inp[cursor - 1] = p;
    cursor++;
    return;
    }
    for (i = inplen - 1; i >= cursor - 1; i--)
    inp[i + 1] = inp[i];
    inp[cursor - 1] = p;
    inp[++inplen] = 0;
    cursor++;
    return;
}

void ctrl_u(void)
{
    int i;

    for (i = 0; i < inplen - cursor + 2; i++)
    inp[i] = inp[i + cursor - 1];
    inplen = strlen(inp);
    cursor = 1;
    return;
}

void ctrl_k(void)
{
    inp[cursor - 1] = 0;
    inplen = cursor - 1;
    return;
}

char *getnextmsg(void)
{
    static char q[1200];
    char *p;
    int i;

    if (!amsg && !msgk) {
    if (inplen > 0 && istrncmp(inp, "/msg ", 5)) {
        sprintf(q, "/msg  %s", inp);
        cursor = 6;
    }
    else if (inplen <= 0) {
        strcpy(q, "/msg ");
        cursor = 6;
    }
    else
        strcpy(q, inp);
    return (q);
    }
    if (!amsg)
    amsg = msgk;
    else {
    if (amsg->next)
        amsg = amsg->next;
    else
        amsg = msgk;
    }
    if (inplen > 0) {
    if (istrncmp(inp, "/msg ", 5) == 0) {
        p = strchr(inp + 5, 32);
        if (!p) {
        sprintf(q, "/msg %s ", amsg->nev);
        cursor = strlen(amsg->nev) + 7;
        }
        else {
        i = p - inp - 5;
        sprintf(q, "/msg %s%s", amsg->nev, p);
        cursor += strlen(amsg->nev) - i;
        }
    }
    else {
        sprintf(q, "/msg %s %s", amsg->nev, inp);
        cursor += strlen(amsg->nev) + 6;
    }
    }
    else {
    sprintf(q, "/msg %s ", amsg->nev);
    cursor = strlen(amsg->nev) + 7;
    }
    return (q);
}

char *getprevmsg(void)
{
    static char q[1200];
    char *p;
    int i;

    if (!amsg && !msgk) {
    if (inplen > 0 && istrncmp(inp, "/msg ", 5)) {
        sprintf(q, "/msg  %s", inp);
        cursor = 6;
    }
    else if (inplen <= 0) {
        strcpy(q, "/msg ");
        cursor = 6;
    }
    return (q);
    }
    if (!amsg)
    amsg = rmsg;
    else {
    if (amsg->prev)
        amsg = amsg->prev;
    else
        amsg = rmsg;
    }
    if (inplen > 0) {
    if (istrncmp(inp, "/msg ", 5) == 0) {
        p = strchr(inp + 5, 32);
        if (!p) {
        sprintf(q, "/msg %s ", amsg->nev);
        cursor = strlen(amsg->nev) + 7;
        }
        else {
        i = p - inp - 5;
        sprintf(q, "/msg %s%s", amsg->nev, p);
        cursor += strlen(amsg->nev) - i;
        }
    }
    else {
        sprintf(q, "/msg %s %s", amsg->nev, inp);
        cursor += strlen(amsg->nev) + 6;
    }
    }
    else {
    sprintf(q, "/msg %s ", amsg->nev);
    cursor = strlen(amsg->nev) + 7;
    }
    return (q);
}

void delmsg(void)
{
    char temp[200];

    if (!amsg)
    amsg = rmsg;
    if (!amsg) {
    /*elemez("@@@ Nincs nev az msg listan."); */
    return;
    }
    if (!amsg->prev) {
    msgk = amsg->next;
    if (!msgk)
        rmsg = NULL;
    else
        msgk->prev = NULL;
    }
    else {
    amsg->prev->next = amsg->next;
    if (amsg->next)
        amsg->next->prev = amsg->prev;
    else
        rmsg = amsg->prev;
    }
    sprintf(temp, "@@@ %s torolve az msg listarol.", amsg->nev);
    elemez(temp);
    free(amsg);
    fv_msglist(NULL);
    return;
}

void scrollit(int c)
{
    struct inplines *s = scrollsorok, *l;
    int i;

    switch (c) {
    case 7:
    case '\n':
        scrollsorok = NULL;
        writesorok(0);
        writeinput();
        if (!nocs)
        printf("\033[?25h");
        break;
    case KEY_UP:
        if (!s->prev)
        break;
        if (!nocs) {
        /*soft scroll up: \033M */
        l = s;
        for (i = 0; i < LINES - 2 - (winsize + ((winsize) ? 1 : 0)); i++) {
            l = l->prev;
            if (!l)
            break;
        }
        printf("\033[%d;1H\033M", winsize + ((winsize) ? 2 : 1));
        if (l)
            printf("\033[K%s", chop(l->s));
        else
            printf("\033[K");
        scrollsorok = s->prev;
        break;
        }
        scrollsorok = s->prev;
        writesorok(0);
        break;
    case KEY_DOWN:
        if (!s->next)
        break;
        if (!nocs) {
        /*soft scroll down: \n */
        printf("\033[%d;1H\n\033[K%s", LINES - 2, chop(s->next->s));
        scrollsorok = s->next;
        break;
        }
        scrollsorok = s->next;
        writesorok(0);
        break;
    case 15:
    case KEY_PGUP:
        if (!s->prev)
        break;
        for (i = 0; i < (LINES - 2 - winsize - ((winsize) ? 1 : 0)) / 2; i++) {
        if (!s->prev)
            break;
        s = s->prev;
        if (!s)
            break;
        }
        if (!s)
        break;
        scrollsorok = s;
        writesorok(0);
        break;
    case 16:
    case KEY_PGDN:
        if (!s->next)
        break;
        for (i = 0; i < (LINES - 2 - winsize - ((winsize) ? 1 : 0)) / 2; i++) {
        if (!s->next)
            break;
        s = s->next;
        if (!s)
            break;
        }
        if (!s)
        break;
        scrollsorok = s;
        writesorok(0);
        break;
        break;
    }
    return;
}

void letsloop(void)
{
    char temp1[300];
    char temp2[1024];
    char *mx;
    unsigned int p = 0;
    unsigned int prevp = 0;
    int x = 1;
    int i,j;
    unsigned int kar = 0;
    struct timeval tv;
    time_t lastact;
    fd_set fs;

    netwrite(" \n");
    lastact2 = time(NULL);
    billlastact = lastact2;
    sprintf(temp2, ">>> Arena Kliens II. Release %s indulas: %s:%d", VER, host, port);
    elemez(temp2);
    while (1) {
    if (!pendinglines) {
        tv.tv_sec = 1;
        tv.tv_usec = 0;
    }
    else {
        tv.tv_sec = 0;
        tv.tv_usec = 0;
    }
    FD_ZERO(&fs);
    if (!botmode)
        FD_SET(0, &fs);
    if (!scrollsorok)
        FD_SET(sock, &fs);
    fflush(stdout);
    lastact = time(NULL);
    if (!scrollsorok)
        x = select(sock + 1, &fs, NULL, NULL, &tv);
    else
        x = select(1, &fs, NULL, NULL, &tv);
    if (loadrc == 2) {
        purgeall();
        loadakiirc();
        loadrc = 0;
    }
    if (sigsemmit[0] != ' ')
        kilepes("SIGNAL");
    if ((x > 0) || pendinglines)
        if ((FD_ISSET(sock, &fs)) || pendinglines) {
        i = netread();
        if (i > 0) {
            if (logfile && ((netbuff[0] == '<') || (netbuff[0] == '*')))
            fprintf(logfile, "%s\n", netbuff);
            elemez(netbuff);
            if (errno) {
            if (novice) {
                sprintf(temp1, "=== HIBA === %s %s", geterrorstr(getlasterror()), errtemp);
            }
            else {
                sprintf(temp1, "=== HIBA === %d: %s %s", errno, geterrorstr(getlasterror()), errtemp);
            }
            errno = 0;
            elemez(temp1);
            }
            if (loadrc == 1) {
            loadakiirc();
            loadrc = 0;
            }
            netbuff[0] = 0;
            netbufflen = 0;
            writestatus();
            writewindowstatus();
            writeinput();
        }
        if (i < 0) {
            elemez(">>> A kapcsolat megszakadt...");
            kilepes("normal shutdown");
        }
        if (i = 0) {
            if (FD_ISSET(sock, &fs))
            echostr("SZIVAS");
            else
            echostr("GAZ VAN");
        }
    }
    if (x > 0)
        if (!botmode)
	if (FD_ISSET(0, &fs)) {
	    i = getch();
            billlastact = time(NULL);
            if (i < 0 && errno == EAGAIN) {
            	errno = 0;
            	continue;
            }
            if (i <= 0) {
            	botmode = 1;
            	continue;
            }
            prevp = p;
            p = i;
            if (amsg && (prevp != 9 && prevp != 18))
            	amsg = NULL;
            if (scrollsorok) {
            	scrollit(p);
            }
            else
            switch (p) {
                case 7:
                    if (!strstr(sorok->s, "Gorgetes kezdete..."))
                        elemez(">>> Gorgetes kezdete...");
                    scrollsorok = sorok;
                    if (!nocs)
                        printf("\033[?25l");
                    writeinput();
                    break;
		    
                case 16:
                case KEY_PGDN:
                    if (topline + winsize > lastwinline)
                        break;
                    topline += winsize;
                    writewindow();
                    writewindowstatus();
                    break;

//                case 15:
		case KEY_END:
                    if (!lastwinline)
                        break;
                    if (topline - winsize < 0)
                        topline = 1;
                    else
                        topline -= winsize;
                    writewindow();
                    writewindowstatus();
                    break;

		case 2:
                    if (!winsize) {
                        winsize = oldwinsize;
                        sprintf(temp2, "%d", winsize);
                        setvar(akii_winsize, temp2);
                        writeinput();
                        break;
                    }
                    winsize = 0;
                    setvar(akii_winsize, "0");
                    writeinput();
                    break;

		case 8:
                case 127:
                    if (inplen) {
                        backspace();
                        writeinput();
                    }
                    break;

		case 21:
                    if (cursor <= 1)
                        break;
                    ctrl_u();
                    writeinput();
                    break;

		case 12:
                    refresh(1);
                    break;

		case 26:
                /*Ctrl-Z: Stoppoljuk le magunkat: */
                    setoriginalterm();
                    printf("\033[r\033[%d;1H\n", LINES);
                    kill(getpid(), SIGSTOP);
                    break;

		case 11:
                    if (cursor > inplen)
                        break;
                    ctrl_k();
                    writeinput();
                    break;

		case 3:
                    kilepes("Ctrl-C");
                    break;

		case KEY_HOME:
                    insertmode ^= 1;
                    writestatus();
                    writewindowstatus();
                    break;
/*
 Valamiert szorakozott, ezert kivettem, amig at nem lesz tervezve...
		case 55: // HOME X alatt
		    kar=getch();
		    if (kar==126) {
			if (cursor <= 1)
			    break;
			cursor=1;
			writeinput();
		    }
		    else { // nem HOME, hanem 7-es billentyu
			if (cursor==inplen) {
                            inp[inplen]='7';
			    inp[inplen + 1]=kar;
			    inp[inplen + 2]='\0';
			    inplen=strlen(inp);
			    cursor=inplen + 1;
			}
			else {
			    for (j=strlen(inp);j>cursor;j--) {
				inp[j + 1] = inp[j - 1];
			    }
			    inp[curcur]='7';
			    inp[++curcur]=kar;
			    cursor+=1;
			    inplen=strlen(inp);
			}
			writeinput();
		    }
		    break;

		case 56: // END X alatt
		    kar=getch();
		    if (kar==126) {
			if (cursor >= inplen + 1)
			    break;
			cursor=inplen + 1;
			writeinput();
		    }
		    else { // nem END, hanem 8 -as billentyu
                        inp[inplen]='8';
			inp[inplen + 1] = kar;
			inp[inplen + 2]='\0';
			inplen=strlen(inp);
			cursor=inplen + 1;
			writeinput();
		    }
		    break;
*/
		case KEY_INS:
                    if (cursor <= 1)
                        break;
                    cursor = 1;
                    writeinput();
                    break;

		case KEY_DEL:
                    if (cursor >= inplen + 1)
                        break;
                    cursor = inplen +1;
                    writeinput();
                    break;

		case 18:    /*Ctrl-R */
                    mx = getprevmsg();
                    strcpy(inp, mx);
                    inplen = strlen(mx);
                    curcur = -1;
                    cursor = inplen + 1;
                    writeinput();
                    break;

		case 9: /*TAB */
                    mx = getnextmsg();
                    strcpy(inp, mx);
                    inplen = strlen(mx);
                    curcur = -1;
//                    cursor=inplen+1;
                    writeinput();
                    break;

		case 4: /*Ctrl-D */
                    delmsg();
                    break;

		case KEY_PGUP:
                    if (inplen && (inplen >= cursor)) {
		        cursor++;
                        curcur = -1;
                        backspace();
                        writeinput();
                    }
                    break;

		case KEY_DOWN:
                    if (inpnum)
                        getnextinp();
                    writeinput();
                    break;

		case KEY_UP:
                    if (inpnum)
                        getprevinp();
                    writeinput();
                    break;

		case KEY_RIGHT:
                    if (cursor >= inplen + 1)
                        break;
                    cursor++;
                    writeinput();
                    break;

		case KEY_LEFT:
                    if (cursor <= 1)
                        break;
                    cursor--;
                    writeinput();
                    break;

		case 13:
                    case '\n':
                    savecursor = 0;
                    putinp();
                    inp[inplen] = '\n';
                    inp[++inplen] = 0;
                    for (inpp = inp; *inpp == 32; inpp++) ;
                    if (*inpp != '/')
                        inpp = NULL;
                    if (inpp) {
                        strcpy(temp2, inpp);
                        inpp = temp2 + 1;
                        resetsoroszlop(0);
                        readparancs(&inpp, PARANCS_EGY_NOVALASZ, 1);
                        if (errno == EEZNEMFV) {
                            inpp = strchr(temp2, ' ');
                            if (inpp)
                                *inpp = 0;
                            inpp = strchr(temp2, '\n');
                            if (inpp)
                                *inpp = 0;
                            inpp = strchr(temp2, '\r');
                            if (inpp)
                                *inpp = 0;
                            if (inuse(temp2 + 1)) {
                                errno = 0;
                                sendline(inp);
                            }
                        }
                        if (errno) {
                            if (!novice)
                                sprintf(temp1, "=== HIBA === %d: %s %s", errno, geterrorstr(getlasterror()), errtemp);
                            else
                                sprintf(temp1, "=== HIBA === %s %s", geterrorstr(getlasterror()), errtemp);
                            errno = 0;
                            elemez(temp1);
                        }
                        if (purge) {
                            purgeall();
                            if (purge == 2) {
                                purge = 0;
                                loadakiirc();
                            }
                            else
                                purge = 0;
                        }
                    }
                    else {
                        sendline(inp);
                    }
                    writestatus();
                    writewindowstatus();
                    inp[inplen = 0] = 0;
                    cursor = 1;
                    writeinput();
                    break;

		default:
                    if ((p > 31) && (p < 256)) {
                        if (inplen > 1022) {
                            printf("\07");
                            break;
                        }
                        savecursor = 0;
                        insert(p);
                        writeinput();
                    }
            }
        }
        if ((i = time(NULL)) != lastact) {
            lookfortimers(i);
            writestatus();
            writewindowstatus();
        }
        setivar(akii_idle, i - lastact2);
        setivar(akii_inputidle, i - billlastact);
        if (i - lastact2 > timeout) {
            sprintf(temp1, ">>> Idle %d masodperce!", timeout);
            elemez(temp1);
        }
    }
    return;
}
