/*
 *  NETREAD, {akii-root}/src/netread.h
 *
 * ==========================================================================
 *
 *                      Arena Kliens II. Releases
 *
 * ==========================================================================
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * A legkiralyabb szovegszerkeszto: VIM - Vi IMproved 5  <http://www.vim.org>
 */

#ifndef _NETREAD_H_
#define _NETREAD_H_ 1

#include <time.h>
#include <sys/time.h>

extern char netbuff[1024];
extern int netbufflen;
extern int pendinglines;

extern int sock;
extern time_t lastact;
extern int sentbyte, recvbyte;

extern struct hostent *hostp;

int netconnect(char *, int, char **);
void netclose(void);
int netread(void);
int netwrite(char *);

#endif
